{************************************************}
{                                                }
{   LINGO                                        }
{   Copyright (c) 1995 Wouter van Wijk           }
{                                                }
{************************************************}

{$R LINGO.RES }

program Lingo;

uses Objects, owindows, dlgs, odialogs,WinDos, WinTypes, WinProcs, Strings, MMSystem, MMTypes;

const
  AantalLetters = 5 - 1; { 5 = AantalLetters }
  AantalRegels = 5 - 1;
  MaxNaamStr = 20;
  Fout = #0;
  Half = #1;
  Goed = #2;
  Finale = #0;
  Nummer1 = #1;
  Nummer2 = #2;
  LingoKrt = #3;
  DemoKrt = #4;
  finalekrt = #5;
  Leeg = #6;
  Ja = 0;
  Nee = 1;
  Team1 = False;
  Team2 = True;
  Aan = True;
  Uit = False;
  ReturnKey = 13;
  BackSpace = 8;
  cm_Nieuw = 101;
  cm_Geluid = 102;
  cm_High = 103;
  cm_Einde = 104;
  cm_About = 105;
  cm_Delay = 106;
  cm_Boxes = 107;
  cm_Edit = 114;
  LINGOER = 1;
  GeluidBeurtWissel = 0;
  GeluidTijdOp = 1;
  GeluidGoed = 2;
  GeluidFout = 3;
  GeluidHalf = 4;
  GeluidDemoMuziek = 5;
  GeluidNummerWeg = 6;
  GeluidWegStrepen = 7;
  GeluidCijferWeg = 8;
  GeluidGelijk = 9;
  GeluidDraaien = 10;
  GeluidNietGeraden = 11;
  GeluidLINGO = 12;
  GeluidBonusLetter = 13;
  GeluidGeenBonus = 14;
  GeluidDoorVoor = 15;
  GeluidWordt = 16;
  GeluidInEenKeer = 17;
  GeluidBallen = 18;
  GeluidGoudenErin = 19;
  GeluidGOUDENBAL = 20;
  GeluidRODEBAL = 21;
  GeluidGROENEBAL = 22;
  GeluidEindeFinale = 23;
  GeluidLaatsteWoord = 24;
  GeluidBonusKrijgen = 25;
  GeluidLINGOFinale = 26;
  GeluidDeelKaartenUit = 27;
  GeluidNietOpKaart = 28;
  GeluidWelOpKaart = 29;
  GeluidWoordGoed = 30;
  GeluidLingoSpelen = 31;
  GeluidNieuwWoord = 32;
  GeluidDubbel = 33;
  Blauw= True;
  Wit = False;
  WelGt = True;
  NietGt = False;
  AantalCijfers = 4;
	maxbeurten = 9;
  Goud =0;
  NietGoud =1;
  GOEDlengte = 2010;
  FOUTlengte = 988;
  NUMWEGlengte = 724;
  HALFlengte = 1386;
  WOORDENFILE = 'LINGO.DAT';
  CIJFWEGlengte = 1694;

type
  LetterArray = array [0 .. AantalLetters] of char;
  CArr = array [0 .. AantalCijfers] of byte;
  CijferArray = array [0 .. AantalLetters] of CArr;

  { Declare TLingo, a TWindow descendant }
  PLingo = ^TLingo;
  TLingo = object(TWindow)
    MaxX: Integer;
    MaxY: Integer;
		procedure LoadWavs;
		procedure Dirsethet;
		procedure TekenHoofd (DC:HDC;R:TRECT);
    constructor Init(ATitle: PChar);
		procedure beurtwissel;
		procedure WMDestroy(Var MSG: TMessage); Virtual wm_First + wm_Destroy;
		procedure FinaleWoord;
		procedure Weg(X,Y:Integer; var CijferTabel: CijferArray);
		procedure ZetScore(BeginX, BeginY, XAchter,  YOnder, VierkantGrootte, TussenVierkant: integer);
    procedure WMTimer(var Message: TMessage); virtual wm_Timer + wm_First;
    procedure Delay( MSec: Integer);
		function TrekGetal (var CijferTabel: CijferArray; var GroeneBal, RodeBal:integer): byte;
		function TrekFinaleGetal:byte;
		procedure RandKaart(var CijferTabel: CijferArray; on_Even: BOOL);
		procedure MenuNieuw(Var Msg: TMessage); Virtual cm_First + cm_Nieuw;
		procedure saveprofiles;
    procedure NieuweKaarten;
    procedure NieuwSpel;
		function Check4Lingo (var CijferTabel: CijferArray) : byte;
    procedure DefCommandProc(var Msg: TMessage); virtual;
    procedure ZetLetter (R: TRect; Letter: Char; LetterStatus: Char);
    procedure ZetKaart;
    procedure LingoPaint;
    procedure Bonus;
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
    procedure GetWindowClass(Var aWndClass: TWndClass); Virtual;
    procedure CalcKey(Key: Char);
		procedure DrawT (DC: HDC; R: TRect; Str: PChar; Kleur: Bool);
    procedure Controle;
    procedure Demo;
    procedure NieuwWoord;
    procedure initprofiles;
    procedure InitWoord;
    procedure NieuweRegel;
    procedure SetupWindow; Virtual;
    procedure PlayWav (Geluidje: Byte);
    procedure GeluidAanUit(Var Msg: TMessage); Virtual cm_First + cm_Geluid;
    procedure BoxesAanUit(Var Msg: TMessage); Virtual cm_First + cm_Boxes;
    procedure DelayAanUit(Var Msg: TMessage); Virtual cm_First + cm_Delay;
    procedure Einde(Var Msg: TMessage); Virtual cm_First + cm_Einde;
		procedure High(var Msg: TMessage); virtual cm_First + cm_High;
    procedure About(Var Msg: TMessage); Virtual cm_First + cm_About;
    procedure BerekenVierkant (X,Y: integer; var R:TRect);
    procedure Hogere_Score (Score: integer);
    procedure wmSize(var Message: TMessage); virtual wm_Size;
  end;

  { Declare TLingoApp, a TApplication descendant }
  TLingoApp = object(TApplication)
    procedure InitMainWindow; virtual;
    procedure InitInstance; virtual;
  end;

THighDialog = object(TDialog)
  procedure SetUpWindow; virtual;
end;

TNameDialog = object(TDialog)
  procedure OK(var Message: TMessage); virtual id_First + id_Ok;
end;


var
  scorehigh1, scorehigh2, scorehigh3, scorehigh4, scorehigh5 : integer;
  NaamHigh1, NaamHigh2, NaamHigh3, NaamHigh4, NaamHigh5: array [0..21] of char;
  NaamHigh: array [0..21] of char;
  bonusbedrag:integer;
	BonusTeam : Byte;
  AantalBeurten, BeurtSelect: Integer;
  ScoreTeam1: Integer;
  ScoreTeam2: Integer;
  RodeBal1: Integer;
  GroeneBal1: Integer;
  RodeBal2: Integer;
  GroeneBal2: Integer;
  EindScore: Integer;
  Gelijk: Bool;
  Beurt: Bool;
  Kaart: Char;
  Boxes: Bool;
  Wavsloaded: Bool;
  Geluid: Bool;
  DelayFlag: Bool;
  LingoWoord: array [0..AantalLetters] of char;
  LingoGoedFout: array [0..AantalLetters] of char;
  CijferTabel1: CijferArray;
  CijferTabel2: CijferArray;
  LingoTabel: array [0 .. AantalRegels ] of LetterArray;
  GoedFout: array [0 .. AantalRegels ] of LetterArray;
  HuidigeRegel, HuidigeRij: Integer;
  FinaleTabel : array [0..70] of Bool;
  MaxArray, AantalWoorden, TijdTeller: longint;
  Winnaar:bool;
  NUMWEG: array [0 .. NUMWEGlengte+2] of char;
  FOUTWAV: array [0 .. FOUTlengte+2] of char;
  CIJFWEG: array [0 .. CIJFWEGlengte+2] of char;
  GOEDWAV: array [0 .. GOEDlengte+2] of char;
  HALFWAV: array [0 .. HALFlengte+2] of char;

{--------------------------------------------}
{--------------------------------------------}
{--------------------------------------------}
{--------------------------------------------}
procedure TLingo.High(var Msg: TMessage);
var
  D: THighDialog;
begin
  D.Init(@Self, 'HOOGSTESCORES');
  D.Execute;
  D.Done;
end;

procedure TNameDialog.OK(var Message: TMessage);
begin
	GetDlgItemText(HWindow, cm_Edit, NaamHigh, 20);
  EndDlg(id_Ok);
end;

procedure THighDialog.SetUpWindow;
var
  CS: array[0..20] of Char;
begin
  TDialog.SetUpWindow;
  SetDlgItemText(HWindow, 115, NaamHigh1);
  SetDlgItemText(HWindow, 116, NaamHigh2);
  SetDlgItemText(HWindow, 117, NaamHigh3);
  SetDlgItemText(HWindow, 118, NaamHigh4);
  SetDlgItemText(HWindow, 119, NaamHigh5);
	Str(ScoreHigh1, CS);
  SetDlgItemText(HWindow, 120, CS);
	Str(ScoreHigh2, CS);
  SetDlgItemText(HWindow, 121, CS);
	Str(ScoreHigh3, CS);
  SetDlgItemText(HWindow, 122, CS);
	Str(ScoreHigh4, CS);
  SetDlgItemText(HWindow, 123, CS);
	Str(ScoreHigh5, CS);
  SetDlgItemText(HWindow, 124, CS);
end;

procedure TLingo.Hogere_Score (Score: integer);
var
  D: TNameDialog;
  A: THighDialog;
begin
  D.Init(@Self, 'GEEFNAAM');
  D.Execute;
  D.Done;
	if score <= scorehigh4 then
  begin
 		scorehigh5 := score;
    strcopy(naamhigh5, naamhigh);
  end
  else
  begin
    scorehigh5 := scorehigh4;
    strcopy(naamhigh5, naamhigh4);
		if score <= scorehigh3 then
  	begin
 			scorehigh4 := score;
	    strcopy(naamhigh4, naamhigh);
  	end
	  else
  	begin
	    scorehigh4 := scorehigh3;
  	  strcopy(naamhigh4, naamhigh3);
			if score <= scorehigh2 then
  		begin
 				scorehigh3 := score;
	    	strcopy(naamhigh3, naamhigh);
	  	end
		  else
  		begin
			  scorehigh3 := scorehigh2;
  	  	strcopy(naamhigh3, naamhigh2);
				if score <= scorehigh1 then
  			begin
 					scorehigh2 := score;
	    		strcopy(naamhigh2, naamhigh);
		  	end
			  else
  			begin
				  scorehigh2 := scorehigh1;
  		  	strcopy(naamhigh2, naamhigh1);
 					scorehigh1 := score;
	   			strcopy(naamhigh1, naamhigh);
		  	end;
		  end;
	  end;
  end;
  A.Init(@Self, 'HOOGSTESCORES');
  A.Execute;
  A.Done;
end;
{--------------------------------------------}

procedure TLingo.PlayWav (Geluidje: Byte);

procedure playsound(naam: pchar; mode: integer);
begin
	if sndplaysound(naam,mode) = false then messagebeep(0);
end;

begin
	if Geluid = Aan then
  	case Geluidje of
			GeluidBeurtWissel: PlaySound('WISSEL.WAV', snd_Async);
		  GeluidTijdOp: PlaySound('TIJDOP.WAV', snd_sync);
		  GeluidGoed:	PlaySound(GOEDWAV, snd_Memory or snd_Async);
		  GeluidFout:	PlaySound(FOUTWAV, snd_Memory or snd_Async);
		  GeluidHalf: playsound(HALFWAV, snd_Memory or snd_Async);
		  GeluidDemoMuziek: playsound('DEMO.WAV',snd_Async or snd_loop);
		  GeluidNummerWeg: playsound(NUMWEG, snd_Memory or snd_Async);
			GeluidWegStrepen: playsound(CIJFWEG, snd_Memory or snd_Async);
			GeluidCijferWeg: playsound('CIJFWEG2.WAV', snd_Async);
			GeluidGelijk: playsound('GELIJK.WAV', snd_Async);
			GeluidDraaien: playsound('DRAAIEN.WAV', snd_Async);
			GeluidNietGeraden: playsound('NIETGOED.WAV', snd_sync);
			GeluidLINGO: playsound('HONDERD.WAV', snd_sync);
			GeluidBonusLetter: playsound('METBONUS.WAV', snd_Async);
			GeluidGeenBonus: playsound('GEENBON.WAV', snd_Async);
			GeluidDoorVoor: playsound('STOPDOOR.WAV', snd_Async);
  		GeluidWordt: playsound('WORDT.WAV', snd_Async);
  		GeluidInEenKeer: playsound('IN1KEER.WAV', snd_Async);
			GeluidBallen: playsound('BALLEN.WAV', snd_sync);
			GeluidGoudenErin: playsound('GOUDERIN.WAV', snd_Async);
			GeluidGOUDENBAL: playsound('GOUDNBAL.WAV', snd_sync);
		 	GeluidRODEBAL: playsound('RODEBAL.WAV', snd_sync);
			GeluidGROENEBAL: playsound('GROENBAL.WAV', snd_sync);
			GeluidEindeFinale: playsound('EINDE.WAV', snd_Async);
			GeluidLaatsteWoord: playsound('LWOORD.WAV', snd_Async);
      GeluidLINGOFinale: playsound('LINFIN.WAV', snd_Async);
      GeluidBonusKrijgen: playsound('BONUS.WAV', snd_Async);
      GeluidDeelKaartenUit: playsound('KAARTEN.WAV', snd_sync);
      GeluidNietOpKaart: playsound('NIETOPK.WAV', snd_sync);
      GeluidWelOpKaart: playsound('WELOPK.WAV', snd_sync);
      GeluidWoordGoed: playsound('GOEDWRD.WAV', snd_Async);
      GeluidLingoSpelen: playsound('LINGOSP.WAV', snd_sync);
      GeluidDubbel: playsound('DUBBEL.WAV', snd_Async);
      GeluidNieuwWoord: playsound('NIEUWW.WAV', snd_Async);
end;
end;

{--------------------------------------------}
procedure TLingo.NieuwWoord;
var
  TempMax, BeginX, BeginY, TussenVierkant, VierkantGrootte: Integer;
  Xachter, YOnder, teller, teller2: integer;
  text :array [0..35] of char;
  prstr :array [0..35] of char;

begin
  KillTimer(HWindow, 1);
  if (aantalbeurten = maxbeurten) or ((kaart = finale) and (AantalBeurten = 5)) then
  begin
    if kaart <> finale then
  	begin
      if ScoreTeam1 = ScoreTeam2 then
      begin
        PlayWav(GeluidGelijk);
		    if Boxes = Aan then MessageBox(HWindow, 'Dus een extra woord om en om.', 'Gelijk spel!', mb_Ok);
      	Gelijk := true;
      end
      else
 	    begin
				if Boxes = Aan then MessageBox(HWindow, 'Draaien naar de finale!', 'De tijd is op!', mb_Ok);
		  	kaart := finale;
	  	  finalewoord;
      end;
    end
    else
    begin
  		tempmax := scoreteam1;
	    for teller := 1 to aantalbeurten do
	    	tempmax := tempmax * 2;
      strcopy(prstr, 'f');
      str(tempmax+EindScore, text);
      strcat(prstr,text);
      strcat(prstr,'.- !');
     	MessageBox(HWindow, 'Je hebt het maximale er uitgehaald!', prstr, mb_Ok);
			if (tempmax + eindscore) > scorehigh5 then
      	hogere_score(Tempmax+eindscore);
    	kaart := demokrt;
      demo;
  		end;
  end;
  if Kaart = Finale then
  begin
  		tempmax := scoreteam1;
	    for teller := 0 to aantalbeurten do
	    	tempmax := tempmax * 2;
      text [0] := #0;
      prstr [0] := #0;
      strcopy(prstr, 'Wil je door gaan voor de f');
      str(tempmax, text);
      strcat(prstr,text);
      PlayWav(GeluidDoorVoor);
     	if (MessageBox(HWindow, prstr, 'Lingo', mb_YesNo)) <> id_Yes then
      begin
      text [0] := #0;
      prstr [0] := #0;
	  		tempmax := scoreteam1;
		    for teller := 1 to aantalbeurten do
		    	tempmax := tempmax * 2;
      	strcopy(prstr, 'Je eindbedrag is: f ');
        str(eindscore + tempmax, text);
        strcat(prstr, text);
	     	MessageBox(HWindow, prstr, 'Lingo', mb_Ok);
				if (tempmax + eindscore) > scorehigh5 then
  	    	hogere_score(Tempmax+eindscore);
  	  	kaart := demokrt;
    	  demo;
      end;

	end;

  if kaart <> demokrt then
  begin
		if ( MaxX * 20 ) > ( MaxY * 35)  then TempMax := MaxY
 	   else TempMax := MaxX * 20 div 35;
		BeginY := TempMax div 50;
 	 	TussenVierkant := (TempMax - BeginY * 2 ) div 100;
	  VierkantGrootte := (TempMax - BeginY * 2 ) div 5 - TussenVierKant;
	  BeginX := BeginY +  2 * VierkantGrootte;
	  XAchter := BeginX + VierkantGrootte * (AantalLetters + 1) + TussenVierkant * (AantalLetters + 3);
	  YOnder := BeginY + VierkantGrootte * (AantalRegels + 1) + TussenVierkant * (AantalRegels + 3);
	  InitWoord;

	  aantalbeurten := aantalbeurten + 1;

	  if Kaart = Finale then
	  begin
			TempMax := Random(4) + 1;
	    LingoGoedFout[Tempmax] := Goed;
	    LingoTabel [Tempmax, 0] := LingoWoord[Tempmax];
	    GoedFout [Tempmax,0] := Goed;
	  end
    else
    begin
      if aantalbeurten = maxbeurten then
       	playwav(GeluidLaatsteWoord)
      else
	    	playwav(GeluidNieuwWoord);
    end;

	  BeurtSelect := 0;
	 	SendMessage(HWindow, wm_Paint,0 ,0);
	  if SetTimer(HWindow, 1, TijdTeller, nil) = 0 then
	  begin
	    MessageBox(HWindow, 'Geen Timers Meer', Nil, mb_Ok);
	    Halt(1);
	  end;
  end;
end;

{-------------------------------}
procedure TLingo.LoadWavs;

function loadwav(naam: pchar; wavbuffer: pchar; lengte: integer): boolean;
var
	teller: integer;
  f: file of char;
  DirInfo: TSearchRec;
  DirParam: String;

begin
 findfirst(naam,faanyfile,DirInfo);

 if strcomp(DirInfo.Name, naam) <> 0 then
 begin
  dirsethet;
	findfirst(naam,faanyfile,DirInfo);
  if strcomp(DirInfo.Name,naam) = 0 then
	begin
	 Assign(f, naam);
	 Reset(f);
	 for teller := 0 to lengte - 1 do
		read (F, wavbuffer[teller]);
	 Close(f);
	 loadwav := true;
	end
  else
	 loadwav := false;
 end
 else
 begin
	Assign(f, naam);
	Reset(f);
	for teller := 0 to lengte - 1 do
		read (F, wavbuffer[teller]);
	Close(f);
	loadwav := true;
 end;

end;

var
	flag: boolean;

begin
 if (wavsloaded = Uit) and (geluid = aan) then
 begin
	 flag := loadwav('NUMWEG.WAV', NUMWEG, NUMWEGlengte);
	 if loadwav('GOED.WAV', GOEDWAV, GOEDlengte) = false then flag := false;
	 if loadwav('CIJFWEG.WAV', CIJFWEG, CIJFWEGlengte) = false then flag := false;
	 if loadwav('HALF.WAV', HALFWAV, HALFlengte) = false then flag := false;
	 if loadwav('FOUT.WAV', FOUTWAV, FOUTlengte) = false then flag := false;
	 if flag = false then
   begin
   	MessageBox(HWindow, 'Kan enkele geluidsbestanden niet vinden!', Nil, mb_Ok);
		wavsloaded := Uit;
   end
   else
		wavsloaded := Aan;
 end;
end;
{-----------------------------------------}

procedure TLingo.InitWoord;
var
	teller, teller2: integer;
  Nummer: LongInt;
  Buffer: array [0 .. 20] of char;
   f: file of char;
   DirInfo: TSearchRec;
 begin
	findfirst(WOORDENFILE,faanyfile,DirInfo);
	if strcomp(DirInfo.Name,WOORDENFILE) <> 0 then
	begin
	  MessageBox(HWindow, 'Kan LINGO.DAT niet vinden!', Nil, mb_Ok);
	  Halt(1);
	end;
   Assign(f, WOORDENFILE);
   Reset(f);
	 nummer := random (FileSize(f));
   Seek(f, nummer);
	 for teller := 0 to 20 do
			read (F, buffer[teller]);
   Close(f);
  teller2 := 0;
  buffer[19] := #0;
  for teller := 0 to 10 do
   begin
	   if buffer [teller] = #$A then
  	 begin
	   	if teller2 = 0 then strlcopy(lingowoord, buffer + teller + 1, 5);
    	teller2 := 1;
   	 end;
   end;
  HuidigeRij:=0;
  HuidigeRegel:=0;
  for teller := 0 to AantalLetters do
  begin
    LingoGoedFout [teller] := Fout;
  	for teller2 := 0 to AantalRegels do
    begin
    	GoedFout [teller, teller2] := Fout;
    	LingoTabel [teller, teller2] := ' ';
    end;
  end;
  LingoGoedFout[0]:= Goed;
  LingoTabel [0, 0] := LingoWoord [0];
  GoedFout [0, 0] := Goed;
  for teller := 1 to AantalLetters do
  	LingoTabel [Teller, HuidigeRegel] := '.';
end;

{--------------------------------------------}

Procedure TLingo.Bonus;
var GoedTeller, Teller: Integer;
	R: TRect;
begin
	GoedTeller := 0;
  for Teller := 0 to AantalLetters do
  	if LingoGoedFout [Teller] = Goed then
    	GoedTeller := GoedTeller + 1;
    if GoedTeller < 4 then
    begin
    	GoedTeller := 0;
      For Teller := 0 to AantalLetters do
      	if LingoGoedFout[Teller] <> Goed then
        	if GoedTeller = 0 then
	        begin
  	      	LingoGoedFout [Teller] := Goed;
  	      	GoedFout [Teller, HuidigeRegel] := Goed;
  	      	LingoTabel [Teller, HuidigeRegel] := LingoWoord[Teller];
	  		 		BerekenVierkant (Teller, HuidigeRegel, R);
            PlayWav(GeluidBonusLetter);
  					ZetLetter (R, LingoWoord[Teller], Goed);
    	      GoedTeller := 1;
				    if Boxes = Aan then MessageBox(HWindow, 'Geen overleg...', 'Bonus Letter!', mb_Ok);
      	  end;
		end;
	if GoedTeller = 0 then
  begin
  	PlayWav(GeluidGeenBonus);
	  if Boxes = Aan then MessageBox(HWindow, 'Je mag overleggen...', 'Geen Bonus Letter', mb_Ok);
  end;
end;

procedure TLingo.NieuweRegel;
var R:Trect;
    Teller, Teller2 : Integer;
    return:Byte;

begin
if HuidigeRegel >= AantalRegels then
begin
 	if kaart <> finale then
  begin
	 if (BeurtSelect < 2) or (Gelijk = true) then
 	 begin
	     BeurtSelect := BeurtSelect + 1;
			 for Teller := 1 to AantalRegels do
			   for Teller2 := 0 to AantalLetters do
				 begin
			   	LingoTabel [Teller2, Teller - 1] := LingoTabel [Teller2, Teller];
		 	 	 	GoedFout [Teller2, Teller - 1] := GoedFout [Teller2, Teller];
				 end;
 		  for Teller := 0 to AantalLetters do
			 begin
	 	  	LingoTabel [Teller, AantalRegels] := ' ';
	 		 	GoedFout [Teller, AantalRegels] := Fout;
			 end;
		 if gelijk = false then beurtwissel;
     SendMessage(HWindow, wm_Paint,0,0);
	   HuidigeRegel := HuidigeRegel -1;
		 NieuweRegel;
     if gelijk = false then Bonus;
	 end
	 	else
	 	begin
	   	for Teller := 0 to AantalLetters do
			begin
	  	 	BerekenVierkant (Teller, HuidigeRegel, R);
        PlayWav(GeluidGoed);
        delay(200);
	  		ZetLetter (R, LingoWoord[Teller], Goed);
 		 	end;
      PlayWav(GeluidNietGeraden);
	    BeurtSelect := 0;
      if Gelijk <> True then NieuwWoord;
		  end;
    end
  else
  begin
  if AantalRegels = HuidigeRegel then
  begin
	   	for Teller := 0 to AantalLetters do
			begin
        delay(200);
	  	 	BerekenVierkant (Teller, HuidigeRegel, R);
        PlayWav(GeluidGoed);
	  		ZetLetter (R, LingoWoord[Teller], Goed);
 		 	end;
      PlayWav(GeluidNietGeraden);
  end
  else
  begin
   	for Teller := 0 to AantalLetters do
		begin
      delay(200);
  	 	BerekenVierkant (Teller, HuidigeRegel, R);
      PlayWav(GeluidGoed);
  		ZetLetter (R, LingoWoord[Teller], Goed);
	 	end;
    if HuidigeRegel > 1 then
    begin
	    PlayWav(GeluidLINGO);
	    if Boxes=Uit then MessageBox(HWindow, 'Woord geraden!', 'Lingo', mb_Ok);
    end
    else
    begin
    	PlayWav(GeluidInEenKeer);
	    if Boxes=Uit then MessageBox(HWindow, 'In een keer!', 'Lingo', mb_Ok);
    end;
	end;
	  Kaart := finalekrt;
	  SendMessage(HWindow, wm_Paint,0 ,0);
    return := NietGoud;
		for teller := 0 to 5 do
     		if return <> Goud then return := trekFinaleGetal;
		if kaart = demokrt then
    	demo
  	else
    begin
	    Kaart := Finale;
			NieuwWoord;
    end
  end;
end
else
 begin
    HuidigeRegel := HuidigeRegel + 1;
    HuidigeRij := 0;
    for teller := 0 to AantalLetters do
    begin
    	if LingoGoedFout [Teller] = Goed then
      begin
    	  LingoTabel [Teller, HuidigeRegel] := LingoWoord[Teller];
  	    GoedFout [Teller, HuidigeRegel] := Goed;
	    end
     else
      LingoTabel [Teller, HuidigeRegel] := '.';
		LingoTabel [0, HuidigeRegel] := LingoWoord [0];
 	 	GoedFout [0, HuidigeRegel] := Goed;
	 	BerekenVierkant (Teller, HuidigeRegel, R);
 	 	ZetLetter (R, LingoTabel [Teller, HuidigeRegel], LingoGoedFout [Teller]);
	end;

 if gelijk = true then
 begin
 	beurtwissel;
  SendMessage(HWindow, wm_Paint,0,0);
 end;

 if SetTimer(HWindow, 1, TijdTeller, nil) = 0 then
 begin
   MessageBox(HWindow, 'Geen Timers Meer', Nil, mb_Ok);
   Halt(1);
 end;

 end;
end;

{--------------------------------------------}
procedure TLingo.Controle;
var
  teller, teller2, teller3 : integer;
  flag : bool;
  R: TRect;
  prstr: array [0..25] of char;
  return : byte;

begin
 KillTimer(HWindow, 1);
 for teller := 0 to AantalLetters do
 	if LingoTabel [Teller, HuidigeRegel] = LingoWoord [Teller] then
  begin
		LingoGoedFout [Teller] := Goed;
		GoedFout [Teller, HuidigeRegel] := Goed;
	end;
 for teller := 0 to AantalLetters do
 begin
 	flag := False;
 	for teller2 := 0 to AantalLetters do
    begin
    	if LingoWoord [Teller] = LingoTabel [Teller, HuidigeRegel] then Flag := True;
    	if LingoWoord [Teller] = LingoTabel [Teller2, HuidigeRegel] then
           	if GoedFout [Teller2, HuidigeRegel] = Fout then
            begin
             	if flag = False then GoedFout [Teller2, HuidigeRegel] := Half;
 	            flag := True;
            end;
    end;
 end;

 for Teller := 0 to AantalLetters do
 begin
    BerekenVierkant (Teller, HuidigeRegel, R);
  	ZetLetter (R, LingoTabel[Teller, HuidigeRegel], GoedFout [Teller, HuidigeRegel]);
    if GoedFout [Teller,HuidigeRegel] = Fout then PlayWav(GeluidFout);
    if GoedFout [Teller,HuidigeRegel] = Goed then PlayWav(GeluidGoed);
    if GoedFout [Teller,HuidigeRegel] = Half then PlayWav(GeluidHalf);
    delay(200);
 end;
 flag := True;
 for Teller := 0 to AantalLetters do {Goed!}
 	if GoedFout [Teller, HuidigeRegel] <> Goed then Flag := False;
 if Flag = True then
	 begin
   if HuidigeRegel > 0 then PlayWav(GeluidWoordGoed)
   else PlayWav(GeluidInEenKeer);
	 for Teller2 := 0 to 1 do
   begin
	  for Teller := 0 to AantalLetters do
	  begin
      delay(50);
	    BerekenVierkant (Teller, HuidigeRegel, R);
	  	ZetLetter (R, LingoTabel[Teller, HuidigeRegel], Fout);
  	end;
	  for Teller := 0 to AantalLetters do
	  begin
      delay(50);
	    BerekenVierkant (Teller, HuidigeRegel, R);
	  	ZetLetter (R, LingoTabel[Teller, HuidigeRegel], Goed);
	  end;
  end;
  delay(2000);

  if kaart <> finale then
  begin
    if gelijk <> true then
    begin
			if Beurt = Team1 then ScoreTeam1 := ScoreTeam1 + 50
			else ScoreTeam2 := ScoreTeam2 + 50;
		  BonusBedrag := BonusBedrag + 50;
		  if Beurt=Team1 then
		  begin
			  Kaart := Nummer1;
			  SendMessage(HWindow, wm_Paint,0 ,0);
		  	if TrekGetal(CijferTabel1, Groenebal1, Rodebal1) <> LINGOER then
        begin
        	delay(500);
				  TrekGetal(CijferTabel1, Groenebal1, Rodebal1);
        end
        else
        	delay(500);
 		  end
			else
		  begin
			  Kaart := Nummer2;
		  	SendMessage(HWindow, wm_Paint,0 ,0);
			  if TrekGetal(CijferTabel2, Groenebal2, Rodebal2) <> LINGOER then
        begin
        	delay(500);
				  TrekGetal(CijferTabel2, Groenebal2, Rodebal2);
        end
        else
        	delay(500);
		 	end;
			Kaart := LingoKrt;
			NieuwWoord;
    end
    else
		begin
      gelijk := false;
      if beurt = team1 then scoreteam2 := -1
      else scoreteam1 := -1;
			if Boxes=Uit then MessageBox(HWindow, 'Draaien naar de finale!', 'Woord geraden!', mb_Ok);
	  	kaart := finale;
  	  finalewoord;
    	nieuwwoord;
    end;
  end
  else
  begin
	  Kaart := finalekrt;
	  SendMessage(HWindow, wm_Paint,0 ,0);
    return := NietGoud;
		for teller := 0 to HuidigeRegel do
     if return <> Goud then return := trekFinaleGetal;
		if kaart = demokrt then
    	demo
    else
    begin
	    Kaart := Finale;
    	nieuwwoord;
    end;
  end;
 end
 else NieuweRegel;
end;

procedure TLingo.DrawT (DC: HDC; R: TRect; Str: PChar; Kleur: Bool);
var
  LogFont : TLogFont;
  aFont: HFont;
begin
With LogFont do
 Begin
    lfHeight := R.Top - R.Bottom;
    lfWidth := 0;
    lfEscapement := 0;
    lfOrientation := 0;
    lfWeight := fw_UltraBold;
    lfUnderLine := 0;
    lfItalic := 0;
    lfStrikeOut := 0;
    lfCharSet:=ANSI_CharSet;
    lfOutPrecision:=Out_Default_Precis;
    lfClipPrecision:=Clip_Stroke_Precis;
    lfQuality := Proof_Quality;
    lfPitchAndFamily := Variable_Pitch Or ff_Modern;
    strcopy(@lfFaceName, 'ARIAL');
 end;
 aFont := CreateFontIndirect (LogFont);
    SetTextColor(DC, RGB(0, 0, 0));
    SetBkMode(DC, transparent);
 	 	SelectObject(DC, aFont);

    R.Bottom := R.Bottom - (R.Bottom - R.Top) div 10;
    R.Top := R.Top - (R.Bottom - R.Top) div 10;

    DrawText (DC, Str, strlen(Str), R, dt_Center or dt_VCenter);

    if Kleur = Wit then SetTextColor(DC, RGB(255, 255, 255))
    else SetTextColor(DC, RGB(90, 255, 255));

    with R do
    begin
      Right := Right - 2;
    	Left := Left - 2;
    	Top := Top - 2;
    	Bottom := Bottom - 2;
    end;

    DrawText (DC, Str, strlen(Str), R, dt_Center or dt_VCenter);
	  DeleteObject (SelectObject(DC,aFont));
	  DeleteObject (SelectObject(DC,aFont));
end;

procedure TLingo.TekenHoofd (DC:HDC;R:TRECT);
var tp: array [0..2] of tpoint;
eenacht : integer;
begin
 with R do
 begin
	eenacht := (right - left) div 8;
	tp[0].x := left + eenacht;
	tp[0].y := top + 3 * eenacht;
	tp[1].x := left + 2  * eenacht;
	tp[1].y := top + eenacht;
	tp[2].x := left +  3 * eenacht;
	tp[2].y := top + 2 * eenacht;
 end;
	polygon(DC, tp, 3);

 with R do
 begin
	eenacht := (right - left) div 8;
	tp[0].x := left + 5 * eenacht;
	tp[0].y := top + 2 * eenacht;
	tp[1].x := left + 6  * eenacht;
	tp[1].y := top + eenacht;
	tp[2].x := left +  7 * eenacht;
	tp[2].y := top + 3 * eenacht;
 end;
	polygon(DC, tp, 3);
 ellipse (DC, R.Left + 3 * eenacht, R.Top + 3 * eenacht,
  R.Left + 3 * eenacht + eenacht div 2, R.Top + 3 * eenacht + eenacht div 2);
 ellipse (DC, R.Left + 5 * eenacht, R.Top + 3 * eenacht,
  R.Left + 5 * eenacht + eenacht div 2, R.Top + 3 * eenacht + eenacht div 2);
 With R do
	 chord (DC, Left + eenacht, Top + 3 * eenacht, Left + 7 * eenacht, top + 7 * eenacht,
    Left + eenacht, Top + 7 * eenacht, Left + 7 * eenacht, Top + 7 * eenacht);
end;

procedure TLingo.ZetLetter (R: TRect; Letter: Char; LetterStatus: Char);
var
  Brush : HBrush;
  Pen : HPen;
  PrStr : array [0 .. 3] of char;
	DC:HDC;
  Temp :Integer;
  Getal: byte;

begin
 DC := GetDC(HWindow);
 PrStr [0] := Letter;
 PrStr [1] := #0;
 Temp := ord (Letter) - 90;

 if Letter = #0 then PrStr [0] := #0;
 getal:=1;
 if Temp > 0 then
 begin
  getal :=0;
 	Str (Temp, PrStr);
 end;
 if Letter = #0 then Getal := 1;
 if Letter = #255 then
 	PrStr [0] := #0;
 Pen := SelectObject (DC, CreatePen (ps_null, 0, RGB(0, 128, 101)));
    case LetterStatus of
    	Fout:
			begin
		  	if Kaart = DemoKrt then Brush := SelectObject (DC, CreateSolidBrush (RGB(192, 192, 192)))
        else Brush := SelectObject (DC, CreateSolidBrush (RGB(0, 128, 101)));
        	    Rectangle (DC, R.Left, R.Top, R.Right, R.Bottom);
      end;
      Half:
      begin
		    if Kaart = DemoKrt then Brush := SelectObject (DC, CreateSolidBrush (RGB(192, 192, 192)))
        else Brush := SelectObject (DC, CreateSolidBrush (RGB(0, 128, 101)));
	            Rectangle (DC, R.Left, R.Top, R.Right, R.Bottom);
		    DeleteObject (SelectObject(DC, Brush));
		    if Kaart = DemoKrt then Brush := SelectObject (DC, CreateSolidBrush (RGB(255, 0, 128)))
		    else Brush := SelectObject (DC, CreateSolidBrush (RGB(160, 160, 0)));
		    Ellipse (DC, R.Left, R.Top, R.Right, R.Bottom);
		    DeleteObject (SelectObject(DC, Brush));
		    Brush := SelectObject (DC, CreateSolidBrush (RGB(255, 0, 0)));
      	if kaart = finalekrt then
					tekenhoofd (DC, R);
      end;
      Goed:
      begin
		    if Kaart = DemoKrt then Brush := SelectObject (DC, CreateSolidBrush (RGB(0, 255, 128)))
        else Brush := SelectObject (DC, CreateSolidBrush (RGB(255, 0, 255)));
		    Rectangle (DC, R.Left, R.Top, R.Right, R.Bottom);
      end;
    end;
    if Getal=0 then
	  With R do
  	begin
		 	Top := Top + ((Right - Left) div 10);
		 	Bottom := Bottom - ((Right - Left) div 10);
		end;
    DrawT (DC, R, PrStr, Wit);
    DeleteObject (SelectObject(DC, Brush));
    DeleteObject (SelectObject(DC, Pen));
		ReleaseDC (HWindow, DC);
end;

{ Construct the TLingoApp's MainWindow of type TLingo }
{--------------------------------------------}
{--------------------------------------------}
{--------------------------------------------}

procedure TLingo.GeluidAanUit(Var Msg: TMessage);
var
	MenuHandle: HMenu;
begin
  MenuHandle := GetMenu(HWindow);
	if Geluid = Aan then
  begin
  	Geluid := Uit;
  	CheckMenuItem (MenuHandle, cm_Geluid, mf_ByCommand or mf_UnChecked);
    MessageBeep (0);
  end
  else
  begin
  	Geluid := Aan;
  	CheckMenuItem (MenuHandle, cm_Geluid, mf_ByCommand or mf_Checked);
    loadwavs;
	  if kaart = demokrt then PlayWav(GeluidDemoMuziek);
  end;
end;

procedure TLingo.DelayAanUit(Var Msg: TMessage);
var
	MenuHandle: HMenu;
begin
  MenuHandle := GetMenu(HWindow);
	if DelayFlag = Aan then
  begin
  	DelayFlag := Uit;
  	CheckMenuItem (MenuHandle, cm_Delay, mf_ByCommand or mf_UnChecked);
  end
  else
  begin
  	DelayFlag := Aan;
  	CheckMenuItem (MenuHandle, cm_Delay, mf_ByCommand or mf_Checked);
  end;
end;

procedure TLingo.BoxesAanUit(Var Msg: TMessage);
var
	MenuHandle: HMenu;
begin
  MenuHandle := GetMenu(HWindow);
	if Boxes = Aan then
  begin
  	Boxes := Uit;
  	CheckMenuItem (MenuHandle, cm_Boxes, mf_ByCommand or mf_UnChecked);
  end
  else
  begin
  	Boxes := Aan;
  	CheckMenuItem (MenuHandle, cm_Boxes, mf_ByCommand or mf_Checked);
  end;
end;

procedure TLingo.About(var Msg: TMessage);
var
  Dialog: TDialog;
begin
  Dialog.Init(@Self, 'ABOUT');
  Dialog.Execute;
  Dialog.Done;
end;

procedure TLingo.Einde(var Msg: TMessage);
begin
  SendMessage (HWindow, wm_Destroy,0,0);
end;

{--------------------------------------------}
procedure TLingo.WMTimer(var Message: TMessage);
begin
	 KillTimer(HWindow, 1);
 	 PlayWav(GeluidTijdOp);
 	 if aantalregels <> HuidigeRegel then
   begin
 	 	BeurtWissel;
		SendMessage (HWindow, wm_Paint,0,0);
   end;
	 NieuweRegel;
end;

{ Rather then handle each accelerator individually with
  command ID response methods, it is possible to handle them
  all at once with the default command procedure. }

{--------------------------------------------}
procedure TLingo.DefCommandProc(var Msg: TMessage);
begin
  if Msg.WParamHi = 0 then
  begin
    CalcKey(Char(Msg.WParamLo));
  end;
  TWindow.DefCommandProc(Msg);
end;

{--------------------------------------------}
procedure TLingo.BerekenVierkant (X,Y: integer; var R:TRect);

var
  TempMax, BeginX, BeginY, TussenVierkant, VierkantGrootte: Integer;

begin
	if ( MaxX * 20 ) > ( MaxY * 35)  then TempMax := MaxY
    else TempMax := MaxX * 20 div 35;
	BeginY := TempMax div 50;

    TussenVierkant := (TempMax - BeginY * 2 ) div 100;
    VierkantGrootte := (TempMax - BeginY * 2 ) div 5 - TussenVierKant;

  BeginX := BeginY +  2 * VierkantGrootte;

 With R do
 begin
  left := BeginX + 1 + TussenVierkant + X * (VierkantGrootte + TussenVierkant);
  top := BeginY + 1 + TussenVierkant + Y * (VierkantGrootte + TussenVierkant);
  right := BeginX + 1 + TussenVierkant + VierkantGrootte + X * ( VierkantGrootte + TussenVierkant);
  bottom := BeginY + 1 + TussenVierkant + VierkantGrootte + Y * (VierkantGrootte + TussenVierkant);
 end;
end;

procedure TLingo.WMDestroy(Var MSG: TMessage);
begin
	KillTimer (HWindow, 1);
  PlayWav(GeluidEindeFinale);
  SaveProfiles;
  TWindow.WMDestroy(Msg);
end;

procedure TLingo.GetWindowClass(Var aWndClass: TWndClass);
begin
	TWindow.GetWindowClass (aWndClass);
	aWndClass.HIcon := LoadIcon(HInstance, 'LINGO');
	aWndClass.HCursor := LoadCursor(HInstance, 'LINGO');
end;

{--------------------------------------------}
procedure TLingo.CalcKey(Key: Char);

var
  TempMax, BeginX, BeginY, TussenVierkant, VierkantGrootte: Integer;
  R: TRect;

begin
 if Kaart <> Demokrt then
 begin
 case Key of
 	#13:
    begin
    	if HuidigeRij = AantalLetters+1 then controle
        else MessageBeep (0);
    end;
	#8: {backspace}
    begin
    	if HuidigeRij > 0 then
        begin
        	HuidigeRij := HuidigeRij - 1;
            LingoTabel [HuidigeRij, HuidigeRegel] := ' ';
            GoedFout [HuidigeRij, HuidigeRegel] := Fout;
            BerekenVierkant (HuidigeRij, HuidigeRegel, R);
            ZetLetter (R, '.', Fout);
        end
        else MessageBeep (0);
    end;
	'A' .. 'Z':
    begin
    	if HuidigeRij <= AantalLetters then
        begin
            BerekenVierkant (HuidigeRij, HuidigeRegel, R);
            LingoTabel [HuidigeRij, HuidigeRegel] := key;
            GoedFout [HuidigeRij, HuidigeRegel] := Fout;
            ZetLetter ( R, Key, Fout);
        	HuidigeRij := HuidigeRij + 1;
		end
        else MessageBeep (0);
    end;
    else MessageBeep (0);
 end;
 end
 else
 begin
 	if key = #13 then
		NieuwSpel
  else MessageBeep (0);
	end;
end;

procedure TLingo.initprofiles;
var profstr : array [0..25] of char;
	code,checksum :integer;
	MenuHandle: HMenu;
begin
  MenuHandle := GetMenu(HWindow);
	Code := GetPrivateProfileInt('Lingo', 'Lichte Beveiliging', 0, 'LINGO.INI');
	BonusBedrag := GetPrivateProfileInt('Lingo', 'Bonus Bedrag', 0, 'LINGO.INI');

	GetPrivateProfileString('Lingo', 'Geluid staat', nil, profstr, 4, 'LINGO.INI');
	if strcomp(profstr,'Uit')=0 then
  	Geluid := Uit;

	GetPrivateProfileString('Lingo', 'Message boxes staan', nil, profstr, 4, 'LINGO.INI');
	if strcomp(profstr,'Uit')=0 then
  	Boxes := Uit;

	GetPrivateProfileString('Lingo', 'Vertraging staat', nil, profstr, 4, 'LINGO.INI');
	if strcomp(profstr,'Uit')=0 then
  	DelayFlag := Uit;

        TijdTeller:=GetPrivateProfileInt('Lingo', 'Vertraging', 0, 'LINGO.INI');
        if tijdteller<1000 then
           tijdteller:=10000;
	GetPrivateProfileString('Lingo', 'Hoogste Naam 1', nil, NaamHigh1, 20, 'LINGO.INI');
	GetPrivateProfileString('Lingo', 'Hoogste Naam 2', nil, NaamHigh2, 20, 'LINGO.INI');
	GetPrivateProfileString('Lingo', 'Hoogste Naam 3', nil, NaamHigh3, 20, 'LINGO.INI');
	GetPrivateProfileString('Lingo', 'Hoogste Naam 4', nil, NaamHigh4, 20, 'LINGO.INI');
	GetPrivateProfileString('Lingo', 'Hoogste Naam 5', nil, NaamHigh5, 20, 'LINGO.INI');
	ScoreHigh1 := GetPrivateProfileInt('Lingo', 'Hoogste Score 1', 0, 'LINGO.INI');
	ScoreHigh2 := GetPrivateProfileInt('Lingo', 'Hoogste Score 2', 0, 'LINGO.INI');
	ScoreHigh3 := GetPrivateProfileInt('Lingo', 'Hoogste Score 3', 0, 'LINGO.INI');
	ScoreHigh4 := GetPrivateProfileInt('Lingo', 'Hoogste Score 4', 0, 'LINGO.INI');
	ScoreHigh5 := GetPrivateProfileInt('Lingo', 'Hoogste Score 5', 0, 'LINGO.INI');
	checksum := scorehigh1 xor scorehigh5 or scorehigh3 and scorehigh4 or scorehigh5 and scorehigh5 xor bonusbedrag;
  if checksum <> code then
  	BonusBedrag:=0;
	if (ScoreHigh1 = 0) or (checksum <> code) then
  begin
  	ScoreHigh1 := 5000;
    Strcopy (NaamHigh1,'Wouter');
  	ScoreHigh2 := 4000;
    Strcopy (NaamHigh2,'Marnix');
  	ScoreHigh3 := 3000;
    Strcopy (NaamHigh3,'Ruben');
  	ScoreHigh4 := 2000;
    Strcopy (NaamHigh4,'Cor');
  	ScoreHigh5 := 1000;
    Strcopy (NaamHigh5,'Egbert');
  end;
end;

procedure TLingo.saveprofiles;
var profstr : array [0..25] of char;
checksum :integer;

begin
	checksum := scorehigh1 xor scorehigh5 or scorehigh3 and scorehigh4 or scorehigh5 and scorehigh5 xor bonusbedrag;
  Str (checksum,profstr);
	WritePrivateProfileString('Lingo', 'Lichte Beveiliging', profstr, 'LINGO.INI');
  Str (bonusbedrag, ProfStr);
	WritePrivateProfileString('Lingo', 'Bonus Bedrag', profstr, 'LINGO.INI');
  if Geluid=Uit then WritePrivateProfileString('Lingo', 'Geluid staat', 'Uit', 'LINGO.INI')
  else WritePrivateProfileString('Lingo', 'Geluid staat', 'Aan', 'LINGO.INI');
  if Boxes=Uit then WritePrivateProfileString('Lingo', 'Message boxes staan', 'Uit', 'LINGO.INI')
  else WritePrivateProfileString('Lingo', 'Message boxes staan', 'Aan', 'LINGO.INI');
  if DelayFlag=Uit then WritePrivateProfileString('Lingo', 'Vertraging staat', 'Uit', 'LINGO.INI')
  else WritePrivateProfileString('Lingo', 'Vertraging staat', 'Aan', 'LINGO.INI');
  Str (ScoreHigh1, ProfStr);
	WritePrivateProfileString('Lingo', 'Hoogste Score 1', profstr, 'LINGO.INI');
  Str (ScoreHigh2, ProfStr);
	WritePrivateProfileString('Lingo', 'Hoogste Score 2', profstr, 'LINGO.INI');
  Str (ScoreHigh3, ProfStr);
	WritePrivateProfileString('Lingo', 'Hoogste Score 3', profstr, 'LINGO.INI');
  Str (ScoreHigh4, ProfStr);
	WritePrivateProfileString('Lingo', 'Hoogste Score 4', profstr, 'LINGO.INI');
  Str (ScoreHigh5, ProfStr);
	WritePrivateProfileString('Lingo', 'Hoogste Score 5', profstr, 'LINGO.INI');
	WritePrivateProfileString('Lingo', 'Hoogste Naam 1', NaamHigh1, 'LINGO.INI');
	WritePrivateProfileString('Lingo', 'Hoogste Naam 2', NaamHigh2, 'LINGO.INI');
	WritePrivateProfileString('Lingo', 'Hoogste Naam 3', NaamHigh3, 'LINGO.INI');
	WritePrivateProfileString('Lingo', 'Hoogste Naam 4', NaamHigh4, 'LINGO.INI');
	WritePrivateProfileString('Lingo', 'Hoogste Naam 5', NaamHigh5, 'LINGO.INI');
end;

{--------------------------------------------}
{ Constructor for a TLingo }
constructor TLingo.Init(ATitle: PChar);
begin
  Randomize;
  TWindow.Init(nil, ATitle);
  Attr.Menu := LoadMenu(HInstance, 'LINGO');
  Boxes := Aan;
  Geluid := Aan;
  DelayFlag := Aan;
  Wavsloaded := Uit;
	initprofiles;
end;

procedure TLingo.NieuwSpel;
begin
  KillTimer (HWindow, 1);
	PlayWav(GeluidLingoSpelen);
  Winnaar := Team1;
  EindScore := 0;
  Gelijk := False;
  aantalbeurten := 0;
  BeurtSelect := 0;
  Groenebal1:=0;
  Groenebal2:=0;
  RodeBal1:=0;
  RodeBal2:=0;
  Beurt := Team1;
  ScoreTeam1 := 0;
  ScoreTeam2 := 0;
	NieuweKaarten;
  Kaart := LingoKrt;
  NieuwWoord;
end;

procedure TLingo.dirsethet;
var
   	Dirtje: String;
    aa,ii: integer;
    flagje: boolean;
begin
  	Dirtje:=paramstr(0);

    flagje := true;
    for ii := length(Dirtje) downto 1 do
    begin
    	if (dirtje[ii] = '\') and (flagje = true) then
      begin
	     	flagje := false;
        aa:=ii;
      end;
    end;

    ii:=length(dirtje)-aa+1;
    delete(dirtje,aa,ii);

    if length(dirtje) = 2 then
    	dirtje := '\';

		chdir(dirtje);
end;

procedure TLingo.SetupWindow;
var	MenuHandle: HMenu;
   DirInfo: TSearchRec;
   DirParam: String;

begin
	findfirst(WOORDENFILE,faanyfile,DirInfo);

  if strcomp(DirInfo.Name,WOORDENFILE) <> 0 then
	begin
	  dirsethet;
		findfirst(WOORDENFILE,faanyfile,DirInfo);
  	if strcomp(DirInfo.Name,WOORDENFILE) <> 0 then
		begin
		  MessageBox(HWindow, 'Kan LINGO.DAT niet vinden!', Nil, mb_Ok);
	  	Halt(1);
		end;
	end;

  MenuHandle := GetMenu(HWindow);
	if Geluid=Uit then
  	CheckMenuItem (MenuHandle, cm_Geluid, mf_ByCommand or mf_UnChecked);
	if Boxes=Uit then
  	CheckMenuItem (MenuHandle, cm_Boxes, mf_ByCommand or mf_UnChecked);
	if DelayFlag=Uit then
  	CheckMenuItem (MenuHandle, cm_Delay, mf_ByCommand or mf_UnChecked);
  LoadWavs;
	Demo;
end;

procedure TLingo.Demo;
var teller, teller2: integer;
begin
  Kaart := DemoKrt;
  for teller := 0 to AantalLetters do
  begin
  	for teller2 := 0 to AantalRegels do
    begin
    	GoedFout [teller, teller2] := Fout;
    	LingoTabel [teller, teller2] := ' ';
    end;
  end;
	LingoTabel [0, 0] := 'G';
	LingoTabel [1, 0] := 'E';
	LingoTabel [2, 0] := 'N';
	LingoTabel [3, 0] := 'O';
	LingoTabel [4, 0] := 'T';
	LingoTabel [0, 1] := 'G';
	LingoTabel [1, 1] := 'E';
	LingoTabel [2, 1] := 'V';
	LingoTabel [3, 1] := 'A';
	LingoTabel [4, 1] := 'L';
	LingoTabel [0, 2] := 'G';
	LingoTabel [1, 2] := 'E';
	LingoTabel [2, 2] := 'L';
	LingoTabel [3, 2] := 'U';
	LingoTabel [4, 2] := 'K';
	GoedFout [0,0] := Goed;
	GoedFout [1,0] := Goed;
	GoedFout [2,0] := Fout;
	GoedFout [3,0] := Fout;
	GoedFout [4,0] := Fout;
	GoedFout [0,1] := Goed;
	GoedFout [1,1] := Goed;
	GoedFout [2,1] := Fout;
	GoedFout [3,1] := Fout;
	GoedFout [4,1] := Half;
	GoedFout [0,2] := Goed;
	GoedFout [1,2] := Goed;
	GoedFout [2,2] := Goed;
	GoedFout [3,2] := Goed;
	GoedFout [4,2] := Goed;
  PlayWav(GeluidDemoMuziek);
	SendMessage(Hwindow, wm_Paint,0,0);
end;

{ Store object values with current window size }
procedure TLingo.wmSize(var Message: TMessage);
begin
  MaxX := integer(Message.lParamLo);
  MaxY := integer(Message.lParamHi);
end;

procedure TLingoApp.InitMainWindow;
begin
  MainWindow := New(PLingo, Init('Lingo'));
end;

procedure TLingoApp.InitInstance;
begin
  TApplication.InitInstance;
  HAccTable := LoadAccelerators(HInstance, 'LINGO');
end;

procedure TLingo.ZetScore(BeginX, BeginY, XAchter,  YOnder, VierkantGrootte, TussenVierkant: integer);
var
  Brush : HBrush;
  PaintDC: HDC;
  Pen:HPen;
  R: TRect;
  Team1X1, Team1X2, Team1Y1, Team1Y2,
  Team2X1, Team2X2, Team2Y1, Team2Y2 :Integer;
  PrStr : array [0..10] of Char;
begin
  PaintDC:= GetDC(HWIndow);
	Pen := SelectObject (PaintDC, CreatePen (ps_null, 0, RGB(0, 128, 101)));
  Brush := SelectObject (PaintDC, CreateSolidBrush (RGB(0, 0, 128)));
	Team1X1 := BeginX - 2 * VierkantGrootte;
	Team1X2 := BeginX + 1;
	Team1Y1 := YOnder - 3 * VierkantGrootte;
	Team1Y2 := YOnder;
	Team2X1 := XAchter - 1;
	Team2X2 := XAchter + 2 * VierkantGrootte;
	Team2Y1 := Team1Y1;
	Team2Y2 := YOnder;
{ Ondergrond Teams }
  rectangle (PaintDC, Team1X1, Team1Y1, Team1X2, Team1Y2);
  rectangle (PaintDC, Team2X1, Team2Y1, Team2X2, Team2Y2);
  DeleteObject (SelectObject (PaintDC, Brush));
  Brush := SelectObject (PaintDC, CreateSolidBrush (RGB(255, 255, 128)));
{ Gele omlijningen }
  rectangle (PaintDC, Team1X1 + TussenVierkant,
   Team1Y1 + TussenVierkant,
   Team1X2 - TussenVierkant,
   Team1Y1 + TussenVierkant + VierkantGrootte);
  rectangle (PaintDC, Team2X1 + TussenVierkant,
   Team2Y1 + TussenVierkant,
   Team2X2 - TussenVierkant,
   Team2Y1 + TussenVierkant + VierkantGrootte);

  rectangle (PaintDC, Team1X1 + TussenVierkant,
   Team1Y1 + TussenVierkant * 3 + VierkantGrootte,
   Team1X2 - TussenVierkant,
   Team1Y2 - TussenVierkant);
  rectangle (PaintDC, Team2X1 + TussenVierkant,
   Team2Y1 + TussenVierkant * 3 + VierkantGrootte,
   Team2X2 - TussenVierkant,
   Team2Y2 - TussenVierkant);

  DeleteObject (SelectObject (PaintDC, Brush));
  Brush := SelectObject (PaintDC, CreateSolidBrush (RGB(0, 128, 101)));
{ Groene vlakjes in gele omlijningen (TEAM) }
  rectangle (PaintDC, Team1X1 + TussenVierkant * 2,
   Team1Y1 + TussenVierkant * 2,
   Team1X2 - TussenVierkant * 2,
   Team1Y1 + VierkantGrootte);
  rectangle (PaintDC, Team2X1 + TussenVierkant * 2,
   Team2Y1 + TussenVierkant * 2,
   Team2X2 - TussenVierkant * 2,
   Team2Y1 + VierkantGrootte);

  DeleteObject (SelectObject (PaintDC, Brush));
  	Brush := SelectObject (PaintDC, CreateSolidBrush (RGB(255, 0, 0)));
 if Beurt = Team1 then
  rectangle (PaintDC, Team1X1 + TussenVierkant * 2,
   Team1Y1 + TussenVierkant * 4 + VierkantGrootte,
   Team1X2 - TussenVierkant * 2,
   Team1Y2 - TussenVierkant * 2)
 else
    rectangle (PaintDC, Team2X1 + TussenVierkant * 2,
	   Team2Y1 + TussenVierkant * 4 + VierkantGrootte,
  	 Team2X2 - TussenVierkant * 2,
	   Team2Y2 - TussenVierkant * 2);

  DeleteObject (SelectObject (PaintDC, Brush));
  Brush := SelectObject (PaintDC, CreateSolidBrush (RGB(128, 128, 128)));
{ Grijs of Rood }
  if Beurt = Team2 then
  rectangle (PaintDC, Team1X1 + TussenVierkant * 2,
   Team1Y1 + TussenVierkant * 4 + VierkantGrootte,
   Team1X2 - TussenVierkant * 2,
   Team1Y2 - TussenVierkant * 2)
  else
	  rectangle (PaintDC, Team2X1 + TussenVierkant * 2,
  	 Team2Y1 + TussenVierkant * 4 + VierkantGrootte,
	   Team2X2 - TussenVierkant * 2,
  	 Team2Y2 - TussenVierkant * 2);

  DeleteObject (SelectObject (PaintDC, Brush));
  Brush := SelectObject (PaintDC, CreateSolidBrush (RGB(255, 255, 128)));
{ Gele omrandingen }
  rectangle (PaintDC, Team1X1 + TussenVierkant * 3,
   Team1Y2 - TussenVierkant * 3 - VierkantGrootte,
   Team1X2 - TussenVierkant * 3,
   Team1Y2 - TussenVierkant * 3);

  rectangle (PaintDC, Team2X1 + TussenVierkant * 3,
   Team2Y2 - TussenVierkant * 3 - VierkantGrootte,
   Team2X2 - TussenVierkant * 3,
   Team2Y2 - TussenVierkant * 3);

  DeleteObject (SelectObject (PaintDC, Brush));
  Brush := SelectObject (PaintDC, CreateSolidBrush (RGB(0, 128, 101)));
{ Groene vlakjes in gele omrandingen }

  rectangle (PaintDC, Team1X1 + TussenVierkant * 4,
   Team1Y2 - TussenVierkant * 2 - VierkantGrootte,
   Team1X2 - TussenVierkant * 4,
   Team1Y2 - TussenVierkant * 4);

  rectangle (PaintDC, Team2X1 + TussenVierkant * 4,
   Team2Y2 - TussenVierkant * 2 - VierkantGrootte,
   Team2X2 - TussenVierkant * 4,
   Team2Y2 - TussenVierkant * 4);

  DeleteObject (SelectObject (PaintDC, Brush));

  With R do
  begin
		Left := Team1X1 + TussenVierkant * 4;
   	Top := Team1Y2 - TussenVierkant * 2 - VierkantGrootte;
   	Right := Team1X2 - TussenVierkant * 4;
   	Bottom := Team1Y2 - TussenVierkant * 4;
  end;

  Str (ScoreTeam1, PrStr);
  Drawt(PaintDC, R, PrStr, Blauw);

  With R do
  begin
		Left := Team2X1 + TussenVierkant * 4;
   	Top := Team2Y2 - TussenVierkant * 2 - VierkantGrootte;
   	Right := Team2X2 - TussenVierkant * 4;
   	Bottom := Team2Y2 - TussenVierkant * 4;
  end;

  Str (ScoreTeam2, PrStr);

  Drawt(PaintDC, R, PrStr, Blauw);

	With R do
  begin
  	Left := Team1X1 + TussenVierkant * 2;
   	Top := Team1Y1 + TussenVierkant * 6;
   	Right := Team1X2 - TussenVierkant * 2;
		Bottom := Team1Y1 + VierkantGrootte - TussenVierKant * 3;
  end;

  Drawt(PaintDC, R, 'TEAM', Blauw);

	With R do
  begin
  	Left := Team2X1 + TussenVierkant * 2;
   	Top := Team2Y1 + TussenVierkant * 6;
   	Right := Team2X2 - TussenVierkant * 2;
		Bottom := Team2Y1 + VierkantGrootte - TussenVierKant * 3;
  end;

  Drawt(PaintDC, R, 'TEAM', Blauw);

	With R do
  begin
		Left := Team1X1 + TussenVierkant * 2;
    Top := Team1Y1 + TussenVierkant * 4 + VierkantGrootte;
		Right := Team1X2 - TussenVierkant * 3;
		Bottom := Team1Y2 - TussenVierkant * 3 - VierkantGrootte;
  end;

  Drawt(PaintDC, R, '1', Blauw);

	With R do
  begin
		Left := Team2X1 + TussenVierkant * 2;
    Top := Team2Y1 + TussenVierkant * 4 + VierkantGrootte;
		Right := Team2X2 - TussenVierkant * 3;
		Bottom := Team2Y2 - TussenVierkant * 3 - VierkantGrootte;
  end;

  Drawt(PaintDC, R, '2', Blauw);
  DeleteObject (SelectObject(PaintDC, Pen));
  ReleaseDC(HWindow, PaintDC);
end;

{--------------------------------------------}
procedure TLingo.LingoPaint;
var
  TempMax, BeginX, BeginY, TussenVierkant, VierkantGrootte, LetterTeller, RegelTeller: Integer;
  Brush : HBrush;
  PaintDC: HDC;
  R: TRect;
  Pen : HPen;
  YOnder, XAchter,
  Team1X1, Team1X2, Team1Y1, Team1Y2,
  Team2X1, Team2X2, Team2Y1, Team2Y2 :Integer;
  PrStr : array [0..10] of Char;
begin
    { Bereken coordinaten }
 PaintDC:=GetDC(HWIndow);
 Pen := SelectObject (PaintDC, CreatePen (ps_null, 0, RGB(0, 128, 101)));
	if ( MaxX * 20 ) > ( MaxY * 35)  then TempMax := MaxY
    else TempMax := MaxX * 20 div 35;
	BeginY := TempMax div 50;

	TussenVierkant := (TempMax - BeginY * 2 ) div 100;
	VierkantGrootte := (TempMax - BeginY * 2 ) div 5 - TussenVierKant;

  BeginX := BeginY +  2 * VierkantGrootte;

  Brush := SelectObject (PaintDC, CreateSolidBrush (RGB(255, 255, 255)));
  Rectangle(PaintDC, BeginX- 2 * VierkantGrootte, BeginY, XAchter + 2 * VierkantGrootte, YOnder);
  DeleteObject (SelectObject (PaintDC, Brush));

  Brush := SelectObject (PaintDC, CreateSolidBrush (RGB(0, 0, 128)));

  XAchter := BeginX + VierkantGrootte * (AantalLetters + 1) + TussenVierkant * (AantalLetters + 3);
  YOnder := BeginY + VierkantGrootte * (AantalRegels + 1) + TussenVierkant * (AantalRegels + 3);

  Rectangle(PaintDC, BeginX, BeginY, XAchter, YOnder);

	if (kaart <> Finale) and (Kaart <> DemoKrt) then ZetScore(BeginX, BeginY, XAchter, YOnder, VierkantGrootte, TussenVierkant);

  DeleteObject (SelectObject (PaintDC, Brush));

  { Vierkantjes }

    for RegelTeller := 0 to AantalRegels do            { Vierkantjes Verticaal }
    begin
        for LetterTeller := 0 to AantalLetters  do      { Vierkantjes Horizontaal }
        begin
            BerekenVierkant(LetterTeller, RegelTeller, R);
						ZetLetter (R, LingoTabel [LetterTeller, RegelTeller], GoedFout [LetterTeller, RegelTeller]);
        end;
    end;

    DeleteObject (SelectObject(PaintDC, Pen));
    ReleaseDC(HWindow, PaintDC);
end;

{ Responds to an incoming "paint" message by redrawing screen. }
procedure TLingo.Paint;
begin
	if Kaart = Finale then LingoPaint;
	if Kaart = DemoKrt then LingoPaint;
	if Kaart = LingoKrt then LingoPaint;
	if Kaart = finalekrt then ZetKaart;
	if Kaart = Nummer1 then ZetKaart;
	if Kaart = Nummer2 then ZetKaart;
end;

Procedure TLingo.Delay(MSec: Integer);
var teller: longint;
begin
  teller := getcurrenttime;
 	if DelayFlag = Aan then
  	while getcurrenttime < (MSec + Teller) do yield;
end;

procedure TLingo.ZetKaart;
var
  TempMax, BeginX, BeginY, TussenVierkant, VierkantGrootte, LetterTeller, RegelTeller: Integer;
  Brush : HBrush;
  PaintDC: HDC;
  R: TRect;
  Pen : HPen;
  YOnder, XAchter,
  Team1X1, Team1X2, Team1Y1, Team1Y2,
  Team2X1, Team2X2, Team2Y1, Team2Y2 :Integer;
  PrStr : array [0..10] of Char;
begin
 { Bereken coordinaten }
 PaintDC:=GetDC(HWIndow);
 Pen := SelectObject (PaintDC, CreatePen (ps_null, 0, RGB(0, 128, 101)));
	if ( MaxX * 20 ) > ( MaxY * 35)  then TempMax := MaxY
    else TempMax := MaxX * 20 div 35;
	BeginY := TempMax div 50;

  TussenVierkant := (TempMax - BeginY * 2 ) div 100;
  VierkantGrootte := (TempMax - BeginY * 2 ) div 5 - TussenVierKant;

  BeginX := BeginY +  2 * VierkantGrootte;

  Brush := SelectObject (PaintDC, CreateSolidBrush (RGB(255, 255, 255)));
  Rectangle(PaintDC, BeginX- 2 * VierkantGrootte, BeginY, XAchter + 2 * VierkantGrootte, YOnder);
  DeleteObject (SelectObject (PaintDC, Brush));

  if Kaart = DemoKrt then Brush := SelectObject (PaintDC, CreateSolidBrush (RGB(0, 0, 0)))
  else Brush := SelectObject (PaintDC, CreateSolidBrush (RGB(0, 0, 128)));

  XAchter := BeginX + VierkantGrootte * (AantalLetters + 1) + TussenVierkant * (AantalLetters + 3);
  YOnder := BeginY + VierkantGrootte * (AantalRegels + 1) + TussenVierkant * (AantalRegels + 3);

  Rectangle(PaintDC, BeginX, BeginY, XAchter, YOnder);

  DeleteObject (SelectObject(PaintDC, Brush));
  { Vierkantjes }

    for RegelTeller := 0 to AantalRegels do            { Vierkantjes Verticaal }
    begin
        for LetterTeller := 0 to AantalLetters  do      { Vierkantjes Horizontaal }
        begin
            BerekenVierkant(LetterTeller, RegelTeller, R);
						if (Kaart = Nummer1) or (Kaart = FinaleKrt) then
            begin
            	if CijferTabel1 [LetterTeller, RegelTeller] = 0 then
              	ZetLetter (R, #0, Half)
              else
              begin
	            	if CijferTabel1 [LetterTeller, RegelTeller] = 255 then
  	            	ZetLetter (R, #255, Fout)
                else
  	            	ZetLetter (R, chr(CijferTabel1 [LetterTeller, RegelTeller] + 90), Fout);
              end;
            end
						else
            	if CijferTabel2 [LetterTeller, RegelTeller] = 0 then
              	ZetLetter (R, #0, Half)
              else
              begin
	            	if CijferTabel2 [LetterTeller, RegelTeller] = 255 then
  	            	ZetLetter (R, #255, Fout)
                else
  	            	ZetLetter (R, chr(CijferTabel2 [LetterTeller, RegelTeller] + 90), Fout);
              end;
            begin
            end;
        end;
    end;
    DeleteObject (SelectObject(PaintDC, Pen));
    ReleaseDC(HWindow, PaintDC);
end;

procedure TLingo.RandKaart(var CijferTabel: CijferArray; on_Even: BOOL);
var Teller, Teller2, Teller3, Teller4: Integer;
Flag: Bool;
R: TRect;
begin
	for Teller := 0 to AantalCijfers do
		for Teller2 := 0 to AantalCijfers do
     	CijferTabel[Teller, Teller2] := 255;
  SendMessage(HWindow, wm_Paint,0 ,0);

	for Teller := 0 to AantalCijfers do
		for Teller2 := 0 to AantalCijfers do
     	CijferTabel[Teller, Teller2] := 0;

	for Teller := 0 to AantalCijfers do
		for Teller2 := 0 to AantalCijfers do
	  begin
 	 		flag := False;
  	 	While Flag = False do
      begin
     		CijferTabel[Teller, Teller2] := Random (68) + 1;

        if on_Even = False then
      	begin
	       if CijferTabel[Teller, Teller2] mod 2 = 1 then                      { even }
 	        CijferTabel [Teller, Teller2] := CijferTabel [Teller, Teller2] + 1;
        end
        else
 	       if CijferTabel[Teller, Teller2] mod 2 = 0 then                      { oneven }
 	        CijferTabel [Teller, Teller2] := CijferTabel [Teller, Teller2] + 1;

     	  flag := True;
        for Teller3 := 0 to AantalCijfers do
        	for Teller4 := 0 to AantalCijfers do
          	if CijferTabel[Teller3, Teller4] = CijferTabel[Teller, Teller2] then
            	if (Teller <> Teller3) or (Teller4 <> Teller2) then
               Flag := False;
       	if kaart = Finalekrt then
        begin
	        if on_Even = False then
           	if CijferTabel[Teller, Teller2] = 33 then flag := false
          else
          	if CijferTabel[Teller, Teller2] = 42 then flag := false;
        end;
      end;
	    BerekenVierkant(Teller, Teller2, R);
	    if kaart = finaleKRT then
      	if (teller = 2) and (teller2 = 2) then
	    	begin
  	    	if on_even = True then CijferTabel[2,2] := 33
	  	    else CijferTabel [2,2] := 42;
      	end;
      PlayWav(GeluidNummerWeg);
      delay(60);
      ZetLetter(R,chr(CijferTabel [Teller, Teller2] + 90), Fout);
		end;
end;

procedure TLingo.Weg(X,Y:Integer; var CijferTabel: CijferArray);
var R: TRect;
begin
	CijferTabel [X,Y] := 0;
  BerekenVierkant (X,Y,R);
  ZetLetter(R, #0, Half);
	delay(200);
end;

procedure tlingo.beurtwissel;
var prstr: array [0..25] of char;
begin
	if kaart <> finale then
  begin
	  strcopy(PrStr, 'Team   is aan de beurt!');
	 	 if Beurt = Team2 then
 		 begin
 			 PrStr[5] := '1';
 	 	  beurt := Team1;
 	 	end
	 	else
 	 	begin
  		PrStr[5] := '2';
   	 	beurt := Team2;
  	end;
		PlayWav(GeluidBeurtWissel);
		MessageBox(HWindow, PrStr, 'TEAM Wissel!', mb_Ok);
  end;
end;

function TLingo.TrekGetal (var CijferTabel: CijferArray; var GroeneBal, RodeBal:integer): byte;
var flag:bool;
teller, teller3, teller4, teller2:integer;
PrStr: array [0..25] of char;
tempstr: array [0..10] of char;

begin
{Groene Bal}
	PlayWav(GeluidBallen);
  Flag := True;
  While flag =True do
		if Random (11 * (GroeneBal + 1)) = 0 then
    begin
      GroeneBal := GroeneBal + 1;
      if GroeneBal = 3 then
      begin
      	PlayWav(GeluidBonusKrijgen);

      	strcopy(prstr, 'Je wint: f ');
        str(Bonusbedrag, tempstr);
        strcat(prstr, tempstr);
	     	MessageBox(HWindow, prstr, 'Groene Bal Nummer 3!', mb_Ok);

      	EindScore := EindScore + Bonusbedrag;
        if Beurt = Team1 then BonusTeam := 1
        else BonusTeam := 2;
        BonusBedrag := 0;
      	GroeneBal := 0;
      end
      else
      begin
      	PlayWav(GeluidGROENEBAL);
   			if Boxes = Aan then MessageBox(HWindow, 'Groene Bal!', 'Lingo', mb_Ok);
      end;
		PlayWav(GeluidBallen);
    end
  	else flag := False;

{Rode Bal}
	flag := true;
	 if rodebal < 3 then
   begin
    if	Random (11 * (RodeBal + 1)) = 0 then
    begin
      RodeBal := RodeBal + 1;
      PlayWav(GeluidRODEBAL);
 			if Boxes = Aan then MessageBox(HWindow, 'Rode Bal!', 'Lingo', mb_Ok);
			if Aantalbeurten <> maxbeurten then beurtwissel;
    	flag := true;
      trekgetal := LINGOER;
    end
	  else flag := False;
   end
   else flag := false;
  if flag = false then
  begin
	 	Flag := False;
 		while flag = False do
	 	begin
		  Teller := Random(5);
 		  Teller2 := Random(5);
	 	 	if CijferTabel [Teller] [Teller2] <> 0 then flag := True;
	 	end;
		strcopy(prstr,'               ');
    Str(CijferTabel[Teller] [Teller2], TempStr);
    Strcat(Prstr,Tempstr);
    PlayWav(GeluidCijferWeg);
	 	weg (Teller, Teller2, CijferTabel);
		delay(700);
	  TrekGetal := Check4Lingo(CijferTabel);
  end;
end;

function TLingo.TrekFinaleGetal:byte;
var flag: bool;
teller, teller2, teller3, teller4:integer;
PrStr: array [0..15] of char;
TempStr: array [0..10] of char;
r:Trect;
begin
	Randomize;
	PlayWav(GeluidBallen);
	if Random (34) = 0 then
  begin
  	PlayWav(GeluidGOUDENBAL);
		if Boxes = Aan then MessageBox(HWindow, 'Gouden Bal !!!', 'Lingo', mb_Ok);
    TrekFinaleGetal := Goud;
  end
  else
  begin
	  Flag := False;
 		while flag = False do
	 	begin
		  Teller := Random(69) + 1;
  		if FinaleTabel [Teller] = NietGt then flag := True;
	  end;
    Str(Teller, TempStr);
		strcopy(prstr,'               ');
    Strcat(Prstr,Tempstr);
		if boxes = aan then MessageBox(HWindow, PrStr, 'Getrokken Getal:', mb_Ok);
    FinaleTabel[Teller] := WelGt;
    Flag := True;
    for Teller2 := 0 to 68 do
    	for Teller3 := 0 to AantalCijfers do
 		   	for Teller4 := 0 to AantalCijfers do
		    	if CijferTabel1 [Teller3] [Teller4] = Teller then
    			begin
            delay (150);
            weg (teller3,teller4, cijfertabel1);
          	Flag := False;
		  	  end;
	  if Check4Lingo(CijferTabel1) = LINGOER then
		 TrekFinaleGetal := Goud
    else
    begin
			TrekFinaleGetal := NietGoud;
	    if flag = True then
      begin
    		PlayWav(GeluidNietOpKaart);
				if Boxes = Aan then MessageBox(HWindow, 'Staat niet op de kaart!', 'Lingo', mb_Ok);
      end
	    else
      begin
  	  	PlayWav(GeluidWelOpKaart);
				if Boxes = Aan then MessageBox(HWindow, 'Staat wel op de kaart', 'AAAIIII', mb_Ok);
      end;
    end;
	end;
end;

procedure TLingo.FinaleWoord;

Var Sc, teller, teller2, sctemp: integer;
PrStr: array [0..20] of char;
PrStr2: array [0..20] of char;
begin
  aantalBeurten := 0;
  kaart := finalekrt;
  PlayWav(GeluidDraaien);
  strcopy (prstr, '     Team  !');
  if ScoreTeam1 < ScoreTeam2 then
  begin
  	Winnaar := Team2;
    if BonusTeam = 1 then EindScore := 0;
    prstr [10] := '2';
		scoreTeam1 := ScoreTeam2;
	  For teller := 0 to 69 do
			if Teller mod 2 <> 0 then FinaleTabel [Teller] := NietGt
      else FinaleTabel [Teller] := WelGt;
  end
  else
  begin
  	Winnaar := Team1;
  	if BonusTeam = 2 then EindScore := 0;
    prstr [10] := '1';
	  For teller := 0 to 69 do
			if Teller mod 2 <> 0 then FinaleTabel [Teller] := WelGt
      else FinaleTabel [Teller] := NietGt;
  end;
	ScoreTeam2 := 0;
	Sc := ScoreTeam1;
  MessageBox(HWindow, prstr, 'Winnaar:', mb_Ok);
	StrCopy (PrStr, '');
	Str(Sc, PrStr2);
	StrCat(PrStr, PrStr2);
  PlayWav(GeluidDubbel);
  kaart := leeg;
  if Boxes = Aan then
  begin
	  for teller := 1 to 6 do
		begin
			MessageBox(HWindow, PrStr, 'Finale', mb_Ok);
			StrCopy (PrStr, 'wordt ');
  	  Sctemp := sc;
    	for teller2 := 1 to teller do
	    	sctemp := sctemp * 2;
			Str(Sctemp, PrStr2);
			StrCat(PrStr, PrStr2);
	    PlayWav(GeluidWordt);
		end;
  end; {if boxes=aan}
  kaart := finalekrt;
  nieuwekaarten;
  kaart := finale;
  PlayWav(GeluidGoudenErin);
end;

procedure TLingo.NieuweKaarten;
var Teller, Teller2:Integer;
Temp : array [0..7] of byte;
flag : bool;

procedure WegKaart (var Cijfertabel: CijferArray);
begin
	PlayWav(GeluidWegStrepen);
	case Teller2 of
  0:	weg (temp[Teller] mod 5, temp[Teller] div 5, CijferTabel);
  1:	weg (temp[Teller] div 5, temp[Teller] mod 5, CijferTabel);
  2:	weg (4 - (temp[Teller] mod 5), 4 - (temp[Teller] div 5), CijferTabel);
  3:	weg (4 - (temp[Teller] div 5), 4 - (temp[Teller] mod 5), CijferTabel);
  4:	weg (temp[Teller] mod 5, 4 - (temp[Teller] div 5), CijferTabel);
  5:	weg (4 - (temp[Teller] div 5), temp[Teller] mod 5, CijferTabel);
	end;
end;

procedure FillTemp(A,B,C,D,E,F,G,H: integer);
begin
	Temp[0] := A;
	Temp[1] := B;
	Temp[2] := C;
	Temp[3] := D;
	Temp[4] := E;
	Temp[5] := F;
	Temp[6] := G;
	Temp[7] := H;
end;

begin
  if Kaart = FinaleKrt then
  begin
    if Winnaar = Team1 then
	  	RandKaart(CijferTabel1, False)
    else
	  	RandKaart(CijferTabel1, True);
  	for Teller := 0 to 24 do
    	if Teller in [0,2,4,6,7,8,10,11,13,14,16,17,18,20,22,24] then
      begin
      	PlayWav(GeluidWegStrepen);
      	Weg(Teller mod 5, Teller div 5, CijferTabel1);
      	FinaleTabel[Teller] := WelGt;
      end;
    if boxes = aan then MessageBox(HWindow, 'Finale Kaart', 'Lingo', mb_Ok);
  end
  else
	begin
		case random (10) of
  		0: FillTemp(0,3,7,11,14,16,17,20);
  		1: FillTemp(1,5,9,10,13,16,18,22);
	  	2: FillTemp(2,3,5,14,15,17,21,23);
  		3: FillTemp(3,4,7,10,15,16,21,24);
  		4: FillTemp(4,5,9,11,12,18,21,23);
	  	5: FillTemp(0,4,7,11,14,15,21,23);
  		6: FillTemp(0,1,8,10,14,17,21,24);
  		7: FillTemp(1,4,5,8,11,17,18,21);
	  	8: FillTemp(1,3,7,11,14,18,20,22);
  		9: FillTemp(2,4,5,7,13,15,21,24);
		end;
    PlayWav(GeluidDeelKaartenUit);
    Teller2 := random(6);
    Kaart := Nummer1;
	 	RandKaart(CijferTabel1, False);
    for Teller := 0 to 7 do
      WegKaart(CijferTabel1);
    if boxes = aan then MessageBox(HWindow, 'Kaart Team 1', 'Lingo', mb_Ok);
		Kaart := Nummer2;
		RandKaart(CijferTabel2, True);
    for Teller := 0 to 7 do
      WegKaart(CijferTabel2);
	  if boxes = aan then MessageBox(HWindow, 'En kaart Team 2', 'Lingo', mb_Ok);
  end;
end;

function TLingo.Check4Lingo (var CijferTabel: CijferArray): byte;
var LC: array [0..4, 0..11] of byte;
teller4, Teller, Teller2 ,teller3:Integer;
Flag : Bool;
LingoArray : array [0..5] of char;
R: TRect;
begin
  strcopy (LingoArray, 'LINGO');
	for Teller := 0 to 4 do
  	for teller2 := 0 to 4 do
    	LC [Teller2] [Teller] := Teller2 + Teller * 5;
	for Teller := 5 to 9 do
  	for teller2 := 0 to 4 do
    	LC [Teller2] [Teller] := Teller2 * 5 + (Teller - 5);
	for Teller := 0 to 4 do
    	LC [Teller] [10] := 20 - 4 * Teller;
	for Teller := 0 to 4 do
    	LC [Teller] [11] := 6 * Teller;
  flag := False;
  Check4Lingo := 0;
  for Teller := 0 to 11 do
  		if Flag = False then
  	  begin
	    	flag := True;
	      for Teller2 := 0 to AantalCijfers do
	      	if CijferTabel [LC[Teller2,Teller] mod 5, LC [Teller2, Teller] div 5] <> 0 then
	         flag := False;

				if Flag <> False then
	      begin
		      for Teller2 := 0 to 4 do
	  	    begin
	    	  	BerekenVierkant (LC [Teller2] [Teller] mod 5, LC [Teller2] [Teller] div 5, R);
	      	  ZetLetter (R, LingoArray[Teller2], Goed);
	        end;
	        if kaart <> finalekrt then
	        begin
	        	PlayWav(GeluidLINGO);
            if Boxes = Aan then MessageBox(HWindow, '100 Punten erbij!', 'LINGO!!!', mb_Ok);
	  		    if beurt = team1 then scoreteam1 := scoreteam1 + 100
	    		  else scoreteam2 := scoreteam2 + 100;
	      		if aantalbeurten <> maxbeurten then nieuwekaarten;
	        end
	        else
	        begin
          	PlayWav(GeluidLINGOFinale);
	        	MessageBox(HWindow, 'Je hebt al je geld verloren!', '%&*$# LINGO', mb_Ok);
	          kaart := demokrt;
	      end;
      	Check4Lingo := LINGOER;
	    end;
	end;
end;

procedure TLingo.MenuNieuw;
begin
  KillTimer (HWIndow, 1);
	NieuwSpel;
end;

{ Declare a variable of type TLingoApp }
var
  LingoApp: TLingoApp;

{ Run the LingoApp }
begin
  LingoApp.Init('Lingo');
  LingoApp.Run;
  LingoApp.Done;
end.
